import {
	mainloop,
	frame,
} from "./window.ts";
import cart from "./cart_unpacked.json" assert { type: "json" };
import { parseCodeSheet } from "./cart_tools.ts";

const game = parseCodeSheet(cart[0].value);

game.init();

await mainloop((_t) => {
	// TODO: use t
	game.update();
	game.draw();
	frame();
});
